#!/bin/sh
# favorites.sh 1.1 - 15 Sep 2014 GPL (radky)
# Add items to Favorites category of openbox menu

#define .desktop file directories
DTD="/usr/share/applications/"
if [[ `ls /usr/local/share/applications/ 2>/dev/null` ]]; then 
 DTD="${DTD} /usr/local/share/applications/"
fi

#define current menu items in Favorites category; exclude favorites hidden by NoDisplay=true parameter
NODISPLAY=$(grep -R '^NoDisplay=true' $DTD | awk -F'/' '{print $NF}' | cut -d':' -f1 | sed -e :a -e '$!N; s/\n/|/; ta')
grep -R '^Categories' $DTD | grep 'Favorite' | awk -F'/' '{print $NF}' | cut -d':' -f1 | grep -vwE "$NODISPLAY" | grep -v "^✫" | sed -e 's/.desktop//g' | sort -f > /tmp/OBM-favorites

#create pipe menu for Favorites category
echo "<openbox_pipe_menu>"

 while read -r line
 do
    if [ -f /usr/share/applications/"$line".desktop ]; then
     DTD="/usr/share/applications/"
    elif [ -f /usr/local/share/applications/"$line".desktop ]; then
     DTD="/usr/local/share/applications/"
    elif [ -f /usr/share/applications/kde4/"$line".desktop ]; then
     DTD="/usr/share/applications/kde4/"
    fi
    echo "<item label=\"$line\">
          <action name=\"Execute\">
          <execute>
            `grep -a '^Exec=' "$DTD""$line".desktop | cut -d'=' -f2 | sed -e 's/\%[a-zA-Z]//'`
          </execute>
          </action>
          </item>"
 done < /tmp/OBM-favorites
 echo -e " <separator/>
 <item label=\"✫Manage menu favorites\">
 <action name=\"Execute\"><execute>ManageFavorites</execute></action>
 </item>"
 echo "</openbox_pipe_menu>"

exit
